Attribute VB_Name = "modUtils"
Option Explicit

Sub ShowError(Optional ByVal strMsg As String = "")
    Dim sTmp As String
    
    Screen.MousePointer = vbDefault
    
    sTmp = "Fehler:" & vbCrLf & vbCrLf
    sTmp = sTmp & Err.Description & vbCrLf
    sTmp = sTmp & "Nummer: " & Err
    If strMsg <> "" Then
        sTmp = sTmp & vbCrLf & "Sub/Function: " & strMsg
    End If
    
    Beep
    
    MsgBox sTmp, vbCritical, "Hiba"
    
End Sub

Sub NumInputCheck(ByRef iKey As Integer)

    If (iKey >= Asc("0") And iKey <= Asc("9")) Or iKey = vbKeyBack Or _
        iKey = Asc(",") Or iKey = Asc(".") Then
            Exit Sub
    Else
            Beep
            iKey = 0
    End If

End Sub

Sub HexInputCheck(ByRef iKey As Integer)

    If (iKey >= Asc("0") And iKey <= Asc("9")) Or iKey = vbKeyBack Or _
       (iKey >= Asc("a") And iKey <= Asc("f")) Or _
       (iKey >= Asc("A") And iKey <= Asc("F")) Then
            Exit Sub
    Else
            Beep
            iKey = 0
    End If

End Sub

Function HexToAsc(strHex As String) As String

    Dim c As String
    Dim n, n1, n2 As Integer
    
    HexToAsc = "."
    
    If Len(strHex) = 2 Then
        c = Right(strHex, 1)
        If IsNumeric(c) Then
            n1 = CInt(c)
        ElseIf c = "A" Or c = "a" Then
            n1 = 10
        ElseIf c = "B" Or c = "b" Then
            n1 = 11
        ElseIf c = "C" Or c = "c" Then
            n1 = 12
        ElseIf c = "D" Or c = "d" Then
            n1 = 13
        ElseIf c = "E" Or c = "e" Then
            n1 = 14
        ElseIf c = "F" Or c = "f" Then
            n1 = 15
        Else
            Exit Function
        End If
        
        c = Left(strHex, 1)
        If IsNumeric(c) Then
            n2 = CInt(c)
        ElseIf c = "A" Or c = "a" Then
            n2 = 10
        ElseIf c = "B" Or c = "b" Then
            n2 = 11
        ElseIf c = "C" Or c = "c" Then
            n2 = 12
        ElseIf c = "D" Or c = "d" Then
            n2 = 13
        ElseIf c = "E" Or c = "e" Then
            n2 = 14
        ElseIf c = "F" Or c = "f" Then
            n2 = 15
        Else
            Exit Function
        End If
        
        n = (16 * n2) + n1
        
        If n >= 32 And n <= 126 Then
            HexToAsc = Chr(n)
        End If
        
    End If

End Function

Function AscToHex(strAsc As String) As String

    Dim n, n1, n2 As Integer
    Dim c1, c2 As String
        
    n = Asc(strAsc)
    
    n1 = n \ 16
    If n1 < 10 Then
        c1 = CStr(n1)
    ElseIf n1 = 10 Then
        c1 = "A"
    ElseIf n1 = 11 Then
        c1 = "B"
    ElseIf n1 = 12 Then
        c1 = "C"
    ElseIf n1 = 13 Then
        c1 = "D"
    ElseIf n1 = 14 Then
        c1 = "E"
    ElseIf n1 = 15 Then
        c1 = "F"
    End If
    
    n2 = n Mod 16
    If n2 < 10 Then
        c2 = CStr(n2)
    ElseIf n2 = 10 Then
        c2 = "A"
    ElseIf n2 = 11 Then
        c2 = "B"
    ElseIf n2 = 12 Then
        c2 = "C"
    ElseIf n2 = 13 Then
        c2 = "D"
    ElseIf n2 = 14 Then
        c2 = "E"
    ElseIf n2 = 15 Then
        c2 = "F"
    End If

    AscToHex = c1 & c2

End Function

Function IntToHex(strInt As String) As String

    Dim n, n1, n2 As Integer
    Dim c1, c2 As String
        
    n = CInt(strInt)
    
    n1 = n \ 16
    If n1 < 10 Then
        c1 = CStr(n1)
    ElseIf n1 = 10 Then
        c1 = "A"
    ElseIf n1 = 11 Then
        c1 = "B"
    ElseIf n1 = 12 Then
        c1 = "C"
    ElseIf n1 = 13 Then
        c1 = "D"
    ElseIf n1 = 14 Then
        c1 = "E"
    ElseIf n1 = 15 Then
        c1 = "F"
    End If
    
    n2 = n Mod 16
    If n2 < 10 Then
        c2 = CStr(n2)
    ElseIf n2 = 10 Then
        c2 = "A"
    ElseIf n2 = 11 Then
        c2 = "B"
    ElseIf n2 = 12 Then
        c2 = "C"
    ElseIf n2 = 13 Then
        c2 = "D"
    ElseIf n2 = 14 Then
        c2 = "E"
    ElseIf n2 = 15 Then
        c2 = "F"
    End If

    IntToHex = c1 & c2

End Function
